searchData={"items":[{"type":"behaviour","title":"Magical","doc":"Documentation for `Magical`.","ref":"Magical.html"},{"type":"function","title":"Magical.from_ics/1","doc":"","ref":"Magical.html#from_ics/1"},{"type":"callback","title":"Magical.from_ics/1","doc":"Parse an iCalendar string and return the result as a Magical.Calendar struct","ref":"Magical.html#c:from_ics/1"},{"type":"function","title":"Magical.from_ics!/1","doc":"","ref":"Magical.html#from_ics!/1"},{"type":"callback","title":"Magical.from_ics!/1","doc":"Parse an iCalendar string and return the result as a Magical.Calendar struct.\nThis function will throw an ArgumentError if the input is invalid","ref":"Magical.html#c:from_ics!/1"},{"type":"function","title":"Magical.to_ics/1","doc":"","ref":"Magical.html#to_ics/1"},{"type":"module","title":"Magical.Calendar","doc":"A representation of a iCalendar VCALENDAR","ref":"Magical.Calendar.html"},{"type":"type","title":"Magical.Calendar.t/0","doc":"","ref":"Magical.Calendar.html#t:t/0"},{"type":"module","title":"Magical.Event","doc":"A representation of a iCalendar VEVENT","ref":"Magical.Event.html"},{"type":"type","title":"Magical.Event.t/0","doc":"","ref":"Magical.Event.html#t:t/0"},{"type":"module","title":"Magical.Parser.DateParser","doc":"Responsible for parsing datestrings in predefined formats with `parse/1`.","ref":"Magical.Parser.DateParser.html"},{"type":"function","title":"Magical.Parser.DateParser.parse/2","doc":"Responsible for parsing datestrings in predefined formats into %DateTime{}\nstructs. Valid formats are defined by the \"Internet Calendaring and Scheduling\nCore Object Specification\" (RFC 2445).\n\n  - **Full text:**      http://www.ietf.org/rfc/rfc2445.txt\n  - **DateTime spec:**  http://www.kanzaki.com/docs/ical/dateTime.html\n  - **Date spec:**      http://www.kanzaki.com/docs/ical/date.html","ref":"Magical.Parser.DateParser.html#parse/2"},{"type":"module","title":"Magical.Parser.TextParser","doc":"Parser for https://icalendar.org/iCalendar-RFC-5545/3-3-11-text.html","ref":"Magical.Parser.TextParser.html"},{"type":"function","title":"Magical.Parser.TextParser.parse/1","doc":"","ref":"Magical.Parser.TextParser.html#parse/1"},{"type":"module","title":"Magical.Serializer","doc":"","ref":"Magical.Serializer.html"},{"type":"function","title":"Magical.Serializer.serialize/1","doc":"","ref":"Magical.Serializer.html#serialize/1"},{"type":"module","title":"Magical.Serializer.CalendarSerializer","doc":"","ref":"Magical.Serializer.CalendarSerializer.html"},{"type":"function","title":"Magical.Serializer.CalendarSerializer.serialize/1","doc":"","ref":"Magical.Serializer.CalendarSerializer.html#serialize/1"},{"type":"module","title":"Magical.Serializer.EventSerializer","doc":"","ref":"Magical.Serializer.EventSerializer.html"},{"type":"function","title":"Magical.Serializer.EventSerializer.do_serialize/1","doc":"","ref":"Magical.Serializer.EventSerializer.html#do_serialize/1"},{"type":"function","title":"Magical.Serializer.EventSerializer.serialize/1","doc":"","ref":"Magical.Serializer.EventSerializer.html#serialize/1"},{"type":"module","title":"Magical.Serializer.KvSerializer","doc":"","ref":"Magical.Serializer.KvSerializer.html"},{"type":"function","title":"Magical.Serializer.KvSerializer.serialize/3","doc":"","ref":"Magical.Serializer.KvSerializer.html#serialize/3"},{"type":"module","title":"Magical.Serializer.TextSerializer","doc":"","ref":"Magical.Serializer.TextSerializer.html"},{"type":"function","title":"Magical.Serializer.TextSerializer.serialize/1","doc":"","ref":"Magical.Serializer.TextSerializer.html#serialize/1"},{"type":"extras","title":"Magical","doc":"# Magical\n\n[![Hex.pm Version](https://img.shields.io/hexpm/v/magical?style=flat-square&labelColor=%2334495e&color=%238e44ad)](https://hex.pm/packages/magical/)\n[![Docs](https://img.shields.io/badge/hexdocs-34495e?style=flat-square)](https://hexdocs.pm/magical/)\n[![Coverage Status](https://coveralls.io/repos/github/jonathanballs/magical/badge.svg?branch=main)](https://coveralls.io/github/jonathanballs/magical?branch=main)\n\nMagical is a [RFC 5545](https://www.ietf.org/rfc/rfc5545.txt) compatible parser\nand serializer for iCalendar files. It parses the file intelligently by\nconverting values into native Elixir types and resolving time zones\nautomatically.\n\nMagical is designed to comply with [Postel's\nlaw](https://en.wikipedia.org/wiki/Robustness_principle) - which means that it\nis lenient in what it accepts and strict in what it produces. It accepts and\nsupports the more common non-standard extensions to iCalendar such as\n`X-WR-TIMEZONE`, `X-WR-CALNAME` or `X-WR-DESC` and will gracefully handle poor\ncharacter escaping and other idiosyncrasies found in real world ICS files.\nInternally it uses [NimbleParsec](https://github.com/dashbitco/nimble_parsec)\nto ensure robust parsing of escaped strings. It has been tested against a\nvariety of edge cases and noncompliant ics files. The iCalendar files that it\nproduces are tested against both the iCalendar spec as well as real calendar\nsoftware.\n\nMagical was built for a side project called [Calapi](https://calapi.io) which\nprovides an API for managing your personal calendars and events.","ref":"readme.html"},{"type":"extras","title":"Installation - Magical","doc":"Just add `magical` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:magical, \"~> 1.0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quickstart - Magical","doc":"```elixir\n\"test.ics\"\n|> File.read!()\n|> Magical.from_ics()\n{:ok,\n %Magical.Calendar{\n   prodid: \"//Magical//Booking//EN\",\n   version: \"2.0\",\n   time_zone: \"Europe/London\",\n   name: nil,\n   description: nil,\n   events: [\n     %Magical.Event{\n       uid: \"6529327f4eabe\",\n       dtstamp: ~U[2023-10-13 12:05:19Z],\n       summary: \"Booking at The King's Arms\",\n       description: \"Your booking is confirmed for 6 people at 2 o'clock\",\n       location: \"251 Tooley Street, London, SE1 2JX\",\n       dtstart: #DateTime<2023-10-13 19:00:00+01:00 BST Europe/London>,\n       dtend: #DateTime<2023-10-13 21:00:00+01:00 BST Europe/London>,\n       class: \"PUBLIC\",\n       created: nil,\n       geo: \"51.501568;-0.075906\",\n       last_modified: nil,\n       organizer: nil,\n       priority: nil,\n       seq: nil,\n       status: nil,\n       transp: \"OPAQUE\",\n       url: nil,\n       recurid: nil,\n       rrule: nil,\n       attach: nil,\n       attendee: nil,\n       categories: nil,\n       comment: nil,\n       contact: nil,\n       exdate: nil,\n       rstatus: nil,\n       related: nil,\n       resources: nil,\n       rdate: nil,\n       x_prop: nil,\n       iana_prop: nil\n     }\n   ]\n }}\n```","ref":"readme.html#quickstart"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2024-present Jonathan Balls\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}